/*	========================================================
*	- NAME:
*	  + Conc Blast Block
*
*	- DESCRIPTION:
*	  + This plugin was mainly made for TFC skill servers
*	  + to keep players from concing one another.
*
*	- CREDITS:
*	  + -hi- for thinking of the idea in an old unapproved plugin.
*
*	-------------
*	Server cvars:
*	-------------
*	- blastblock <0/1/2/3>
*	  + Setting to 0 will blast everyone.
*	  + Setting to 1 will blast the conc owner and enemies.
*	  + Setting to 2 (default) will blast only the conc owner.
*	  + Setting to 3 won't blast anyone.
*
*	---------
*	Versions:
*	---------
*	1.1 - Added the option to not blast anyone (08-29-2007).
*	1.0 - First version made and works (08-27-2007).
*/

#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN "Conc Blast Block"
#define VERSION "1.1"
#define AUTHOR "hlstriker"

new blastblock;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	RegisterHam(Ham_TFC_TakeConcussionBlast, "player", "hook_TakeConcussionBlast");
	blastblock = register_cvar("blastblock", "2");
}

public hook_TakeConcussionBlast(this, entityid)
{
	new owner = pev(entityid, pev_owner);
	
	if(get_pcvar_num(blastblock) == 3)
	{
		// Don't blast anyone
		return HAM_SUPERCEDE;
	}
	else if(get_pcvar_num(blastblock) == 2)
	{
		// Blast owner only
		if(owner != this)
			return HAM_SUPERCEDE;
	}
	else if(get_pcvar_num(blastblock) == 1)
	{
		// Blast owner + enemies
		new ownerTeam = pev(owner, pev_team);
		new hitTeam = pev(this, pev_team);
		if(owner != this && ownerTeam == hitTeam)
			return HAM_SUPERCEDE;
	}
	
	return HAM_HANDLED;
}